chiark / gitweb /
Use force flag when pushing tags
[dgit.git] / tests / tests / drs-push-rejects
index eab44a5..3a70947 100755 (executable)
@@ -11,18 +11,17 @@ t-worktree drs
 cd $p
 
 mustfail () {
-       local wantmsg="$1"; shift
-       set +e
-       git push origin "$@" 2>&1 |tee $tmp/mustfail.txt
-       ps="${PIPESTATUS[*]}"
-       set -e
-       case $ps in
-       "0 0")  fail "push unexpectedly succeeded: $*" ;;
-       *" 0")  ;;
-       *)      fail "tee failed"  ;;
-       esac
-       if ! fgrep "$wantmsg" $tmp/mustfail.txt >/dev/null; then
-               fail "error message not found"
+       local mpat="$1"; shift
+       t-expect-push-fail "$mpat" \
+       git push origin "$@"
+}
+
+mustsucceed () {
+       t-reporefs pre-push
+       git push origin "$@"
+       t-reporefs post-push
+       if diff $tmp/show-refs.{pre,post}-push >$tmp/show-refs.diff; then
+               fail "no refs updated"
        fi
 }
 
@@ -51,6 +50,39 @@ tag_signer='-a'
 mktag
 mustfail 'missing signature' $push_spec
 
+git cat-file tag $tag_name >goodtag
+
+for h in object type tag; do
+  for how in missing dupe; do
+
+    case $how in
+    missing) perl -pe 's/^tag /wombat$&/ if 1..m/^$/'  <goodtag >badtag ;;
+    dupe)   perl -pe 'print if 1..m/^$/ and m/^'$h' /' <goodtag >badtag ;;
+    esac
+
+    rm -f badtag.asc
+    gpg --detach-sign --armor -u Senatus badtag
+    cat badtag.asc >>badtag
+
+    set +e
+    LC_MESSAGES=C git hash-object -w -t tag badtag >badtag.hash 2>badtag.err
+    rc=$?
+    set -e
+
+    if [ $rc = 128 ] && grep 'fatal: corrupt tag' badtag.err; then
+      continue
+    elif [ $rc != 0 ]; then
+      cat badtag.err
+      fail "could not make tag"
+    fi
+
+    read <badtag.hash badtag
+    git update-ref refs/tags/$tag_name $badtag
+
+    mustfail 'multiple headers '$h' in signed tag object' $push_spec
+  done
+done
+
 prep unstable sid
 tag_message='something'
 mktag
@@ -66,20 +98,53 @@ mustfail 'sid != sponge' HEAD:refs/dgit/sponge $push_spec2
 prep unstable sid
 mktag
 mustfail 'push is missing tag ref update' $push_spec1
-mustfail 'push is missing head ref update' $push_spec2
+mustfail 'push is missing head ref update' +$push_spec2
 mustfail 'pushing unexpected ref' $push_spec HEAD:refs/wombat
 mustfail 'pushing multiple heads' $push_spec HEAD:refs/dgit/wombat
 mustfail 'pushing multiple tags' $push_spec HEAD:refs/tags/debian/wombat
 
 prep unstable sid
 mktag
+echo woody >$tmp/suites
+mustfail 'unknown suite' $push_spec
+cp $root/tests/suites $tmp/.
+
+# fixme:
+#    or reject "command string not understood";
+#    reject "unknown method" unless $mainfunc;
+
+
+prep unstable sid
+mktag
 cp $tmp/dm.gpg $tmp/dd.gpg
-mustfail 'key not found in keyrings'
+mustfail 'key not found in keyrings' $push_spec
+
+prep unstable sid
+mktag HEAD~
+mustfail 'tag refers to wrong commit' $push_spec
+
+prep unstable sid
+mktag HEAD~:
+mustfail 'tag refers to wrong kind of object' $push_spec
+
+prep unstable sid
+tag_name=debian/wombat
+mktag
+#git update-ref debian/$version debian/wombat
+mustfail 'tag name in tag is wrong' \
+       refs/tags/debian/wombat:refs/tags/debian/$version $push_spec1
 
 prep unstable sid
-git push origin $push_spec # succeeds
 mktag
-mustfail 'not replacing previously-pushed version' $push_spec
+mustsucceed $push_spec # succeeds
+
+mktag
+mustfail 'push is missing head ref update' $push_spec1 +$push_spec2
+
+git commit --allow-empty -m 'Dummy update'
+mktag
+mustfail 'not replacing previously-pushed version' +$push_spec1 +$push_spec2
+git reset --hard HEAD~
 
 prep_dm_mangle () {
        prep unstable sid
@@ -90,9 +155,19 @@ prep_dm_mangle () {
        mktag
 }
 
+git commit --amend --message 'Make it not a fast forward'
+version=3-2_dummy2
+prep unstable sid
+mktag
+mustfail 'not fast forward on dgit branch' +$push_spec1 +$push_spec2
+
 git checkout v2
 version=3-2_dummy2
 
+prep_dm_mangle ''
+perl -i.bak -ne 'print if 1..s/(pari-extra).*\n/$1/' $tmp/dm.txt
+mustfail '' $push_spec # malformed (truncated) dm.txt; don't care about msg
+
 prep_dm_mangle 's/allow:/asponge:/i'
 mustfail 'missing Allow section in permission' $push_spec
 
@@ -103,6 +178,6 @@ prep_dm_mangle 'y/0-9/5-90-4/ if m/^fingerprint:/i'
 mustfail "not in permissions list although in keyring" $push_spec
 
 prep_dm_mangle ''
-git push origin $push_spec # succeeds
+mustsucceed $push_spec # succeeds
 
 echo ok.